import { PublicKey } from "@solana/web3.js";
import * as anchor from "@project-serum/anchor";
import { Program } from "@project-serum/anchor";
import { BigNumber } from "ethers";
export declare const ERC20RouterHelperConstructor: (routerProgram: Program) => {
    findRouterVaultPDA: () => Promise<[PublicKey, number]>;
    findEgressPayloadPDA: (userPublicKey: any) => Promise<[PublicKey, number]>;
    findRouterStoragePDA: () => Promise<[PublicKey, number]>;
    findChainInfoPDA: (chainId: any) => Promise<[PublicKey, number]>;
    findRouterSigningPDA: () => Promise<[PublicKey, number]>;
    findWrappedTokenPDA: (nativeChainTokenAddressBytes: Uint8Array, nativeChainId: number) => Promise<[PublicKey, number]>;
    getInitEgressPayloadAccountTx: (payloadPDA: any, userPublicKey: any) => Promise<anchor.web3.Transaction>;
    getEgressTxs: (tokenAddressPK: PublicKey, targetChainId: any, amount: any, receiverAddress: any, user: any, teleportProgramId: any, teleportFeeCalculatorStoragePDA: any, teleportFeeCollectorPDA: any) => Promise<{
        preTxs: anchor.web3.Transaction[];
        egressTx: anchor.web3.Transaction;
    }>;
    getOnTeleportMessageInstruction: (transmission: any, payloadAccountPDA: any, user: any) => Promise<{
        pretxs: any[];
        onTeleportMessageInstruction: anchor.web3.TransactionInstruction;
    }>;
    parsePayload: (payload: any) => Payload;
    isERC20Claim: (claim: ClaimTransmission) => Promise<boolean>;
    getDAppId: () => Promise<Uint8Array>;
};
declare class Payload {
    header: BigNumber;
    envelope: Envelope;
    constructor(payloadBytes: any);
}
declare class Envelope {
    deliveryFee: BigNumber;
    sender: Uint8Array;
    receiver: Uint8Array;
    action: Action;
    constructor(envelopeBytes: any);
}
declare class Action {
    actionId: number;
    nativeAddress: Uint8Array;
    dataBytes: Uint8Array;
    constructor(actionBytes: any);
    getMintData(): {
        amount: any;
        nativeChainId: any;
        tokenName: any;
        tokenSymbol: any;
        tokenDecimals: any;
    };
}
export {};
