/// <reference types="bn.js" />
import { PublicKey } from "@solana/web3.js";
import * as anchor from "@project-serum/anchor";
import { BN, Program } from "@project-serum/anchor";
import { BigNumber } from "ethers";
export declare const ERC721RouterHelperConstructor: (routerProgram: Program) => {
    findRouterVaultPDA: () => Promise<[PublicKey, number]>;
    findEgressPayloadPDA: (userPublicKey: any) => Promise<[PublicKey, number]>;
    findRouterStoragePDA: () => Promise<[PublicKey, number]>;
    findChainInfoPDA: (chainId: any) => Promise<[PublicKey, number]>;
    findRouterSigningPDA: () => Promise<[PublicKey, number]>;
    findWrappedTokenPDA: (nativeChainTokenAddressBytes: Uint8Array, nativeTokenId: anchor.BN) => Promise<[PublicKey, number]>;
    getInitEgressPayloadAccountTx: (payloadPDA: any, userPublicKey: any) => Promise<anchor.web3.Transaction>;
    getEgressTxs: (tokenAddressPK: PublicKey, targetChainId: any, amount: any, receiverAddress: any, user: any, teleportProgramId: any, teleportFeeCalculatorStoragePDA: any, teleportFeeCollectorPDA: any) => Promise<{
        preTxs: anchor.web3.Transaction[];
        egressTx: anchor.web3.Transaction;
    }>;
    getOnTeleportMessageInstruction: (transmission: any, payloadAccountPDA: any, user: any) => Promise<{
        pretxs: any[];
        onTeleportMessageInstruction: anchor.web3.TransactionInstruction;
    }>;
    parsePayload: (payload: any) => Payload;
    isERC721Claim: (claim: ClaimTransmission) => Promise<boolean>;
    getDAppId: () => Promise<Uint8Array>;
};
declare class Payload {
    header: BigNumber;
    envelope: Envelope;
    constructor(payloadBytes: any);
}
declare class Envelope {
    sender: Uint8Array;
    receiver: Uint8Array;
    actions: Action[];
    constructor(envelopeBytes: any);
}
declare class Action {
    actionId: number;
    nativeAddress: Uint8Array;
    dataBytes: Uint8Array;
    constructor(actionBytes: any);
    getMintData(): {
        tokenIds: anchor.BN[];
        nativeChainId: number;
        uris: string[];
        tokenName: string;
        tokenSymbol: string;
    };
    getUnlockData(): {
        tokenIds: anchor.BN[];
    };
}
export {};
